/************************************************************************
 *
 *			ob|rdqud
 *
 *				: NCAgca֐
 *		t@C	: cdb.c
 *		쐬		: s.aizawa
 *
 ************************************************************************/

#include "pcsos.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "pcsclnt.h"

#ifdef	OS_VMS
#define min(a,b)	(((a) < (b)) ? (a) : (b))
#endif

/*=======================================================================
 |
 |		f[^x[XI[v
 |
 |	PFCB	PSDBOpen(pCCB, fileName)
 |
 |		PCCB	pCCB;		NCAgubN|C^
 |		CHAR	*fileName;	f[^t@C
 |
 |		PFCB	Ԓl		t@CubN|C^
 |
 =======================================================================*/
PFCB	PSENTRY PSDBOpen(PCCB pCCB, CHAR *fileName)
{
	PFCB	pFCB;
	struct	PRM_DB_OPEN	*pParam;

	if ((pFCB = malloc(sizeof(FCB))) == NULL) {
		pCCB->errorCode = ERROR_CLIENT_MEMORY;
		return NULL;
	}

	memset(pFCB, 0, sizeof(FCB));
	pFCB->fileType = FILETYPE_DB;
	pFCB->pCCB = pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		if ((pCCB->errorCode = DBOpen(fileName, &pFCB->pDB, PERMISSION_ALL)) != 0) {
			free(pFCB);
			return NULL;
		}
		pFCB->DBInf.recSize = pFCB->pDB->dp->lRec;
	} else {
		if (strlen(fileName) >= sizeof(pParam->fileName)) {
			pCCB->errorCode = ERROR_CLIENT_PARAMETER;
			return NULL;
		}
retry:
		pParam = (struct PRM_DB_OPEN *)pCCB->command.param;
		strcpy(pParam->fileName, fileName);

		pCCB->pOutData = &pFCB->DBInf;

		if ((pCCB->errorCode = SendCommand(pCCB, FC_DB_OPEN, sizeof(struct PRM_DB_OPEN), 0)) == ERROR_NOLOGIN) {
			if (LoginDialog(pCCB))
				goto retry;
		}

		if (pCCB->errorCode != 0) {
			free(pFCB);
			return NULL;
		}

		pFCB->fileHandle = pCCB->response.ret.sValue;
	}

	pFCB->readSize = pFCB->DBInf.recSize;

	pFCB->chain = pCCB->pFCB;
	pCCB->pFCB = pFCB;

	return pFCB;
}

/*=======================================================================
 |
 |		f[^x[X쐬
 |
 |	PFCB	PSDBCreate(pCCB, fileName, dip, nField)
 |
 |		PCCB	pCCB;		NCAgubN|C^
 |		CHAR	*fileName;	f[^t@C
 |		PDBF_I	dip;		tB[h
 |		SHORT	nField;		tB[h
 |
 |		PFCB	Ԓl		t@CubN|C^
 |
 =======================================================================*/
PFCB	PSENTRY PSDBCreate(PCCB pCCB, CHAR *fileName, PDBF_I dip,
								SHORT nField)
{
	PFCB	pFCB;
	struct	PRM_DB_CREATE	*pParam;

	if ((pFCB = malloc(sizeof(FCB))) == NULL) {
		pCCB->errorCode = ERROR_CLIENT_MEMORY;
		return NULL;
	}

	memset(pFCB, 0, sizeof(FCB));
	pFCB->fileType = FILETYPE_DB;
	pFCB->pCCB = pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		if ((pCCB->errorCode = DBCreate(fileName, dip, nField, &pFCB->pDB, PERMISSION_ALL)) != 0) {
			free(pFCB);
			return NULL;
		}
		pFCB->DBInf.recSize = pFCB->pDB->dp->lRec;
	} else {
		if (strlen(fileName) >= sizeof(pParam->fileName)) {
			pCCB->errorCode = ERROR_CLIENT_PARAMETER;
			return NULL;
		}
retry:
		pParam = (struct PRM_DB_CREATE *)pCCB->command.param;
		strcpy(pParam->fileName, fileName);
		pParam->nField = nField;
		pCCB->pInData = dip;

		pCCB->pOutData = &pFCB->DBInf;

		if ((pCCB->errorCode = SendCommand(pCCB, FC_DB_CREATE, sizeof(struct PRM_DB_CREATE), sizeof(DBF_I) * nField)) == ERROR_NOLOGIN) {
			if (LoginDialog(pCCB))
				goto retry;
		}

		if (pCCB->errorCode != 0) {
			free(pFCB);
			return NULL;
		}

		pFCB->fileHandle = pCCB->response.ret.sValue;
	}

	pFCB->readSize = pFCB->DBInf.recSize;

	pFCB->chain = pCCB->pFCB;
	pCCB->pFCB = pFCB;

	return pFCB;
}

/*=======================================================================
 |
 |		f[^x[XN[Y
 |
 |	VOID	PSDBClose(pFCB)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |
 =======================================================================*/
VOID	PSENTRY PSDBClose(PFCB pFCB)
{
	PCCB	pCCB;
	PFCB	*pPFCB;
	struct	PRM_DB_CLOSE	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBClose(pFCB->pDB);
	} else {
		pParam = (struct PRM_DB_CLOSE *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;

		err = SendCommand(pCCB, FC_DB_CLOSE,
					sizeof(struct PRM_DB_CLOSE), 0);
	}

	for (pPFCB = &pCCB->pFCB; *pPFCB != 0; pPFCB = &(*pPFCB)->chain) {
		if ((*pPFCB) == pFCB) {
			*pPFCB = (*pPFCB)->chain;
			break;
		}
	}

	if (err != 0) {
		pCCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}

	if (pFCB->pReadBuffer != NULL)
		free(pFCB->pReadBuffer);

	free(pFCB);
}

/*=======================================================================
 |
 |		Sf[^x[XN[Y
 |
 |	VOID	PSDBCloseAll(pCCB)
 |
 |		PFCB	pCCB;		NCAgubN|C^
 |
 =======================================================================*/
VOID	PSENTRY PSDBCloseAll(PCCB pCCB)
{
	PFCB	pFCB;

loop:
	for (pFCB = pCCB->pFCB; pFCB != NULL; pFCB = pFCB->chain) {
		if (pFCB->fileType == FILETYPE_DB) {
			PSDBClose(pFCB);
			goto loop;
		}
	}
}

/*=======================================================================
 |
 |		t@C|o
 |
 |	VOID	PSDBFlush(pFCB)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |
 =======================================================================*/
VOID	PSENTRY PSDBFlush(PFCB pFCB)
{
	PCCB	pCCB;
	struct	PRM_DB_FLUSH	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBFlush(pFCB->pDB);
	} else {
		pParam = (struct PRM_DB_FLUSH *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;

		err = SendCommand(pCCB, FC_DB_FLUSH,
					sizeof(struct PRM_DB_FLUSH), 0);
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}
}

/*=======================================================================
 |
 |		St@C|o
 |
 |	VOID	PSDBFlushAll(pCCB)
 |
 |		PFCB	pCCB;		NCAgubN|C^
 |
 =======================================================================*/
VOID	PSENTRY PSDBFlushAll(PCCB pCCB)
{
	PFCB	pFCB;

	for (pFCB = pCCB->pFCB; pFCB != NULL; pFCB = pFCB->chain) {
		if (pFCB->fileType == FILETYPE_DB)
			PSDBFlush(pFCB);
	}
}

/*=======================================================================
 |
 |		CfbNXt@CI[v
 |
 |	SHORT	PSDBIndex(pFCB, fileName)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |		CHAR	*fileName;	CfbNXt@C
 |
 |		SHORT	Ԓl		CfbNXt@Cԍ
 |
 =======================================================================*/
SHORT	PSENTRY PSDBIndex(PFCB pFCB, CHAR *fileName)
{
	PCCB	pCCB;
	struct	PRM_DB_INDEX	*pParam;
	SHORT	indexNo = 0;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBIndex(pFCB->pDB, fileName, &indexNo);
	} else {
		if (strlen(fileName) >= sizeof(pParam->fileName)) {
			err = ERROR_CLIENT_PARAMETER;
			goto ret;
		}

		pParam = (struct PRM_DB_INDEX *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;
		strcpy(pParam->fileName, fileName);

		err = SendCommand(pCCB, FC_DB_INDEX,
					sizeof(struct PRM_DB_INDEX), 0);

		indexNo = pCCB->response.ret.sValue;
	}
ret:
	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}

	return indexNo;
}

/*=======================================================================
 |
 |		CfbNXt@C쐬
 |
 |	SHORT	PSDBIdxCreate(pFCB, fileName, key, uniq)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |		CHAR	*fileName;	CfbNXt@C
 |		CHAR	*key;		L[
 |		SHORT	uniq;		OFL[̏d@PFȂ
 |
 |		SHORT	Ԓl		CfbNXt@Cԍ
 |
 =======================================================================*/
SHORT	PSENTRY PSDBIdxCreate(PFCB pFCB, CHAR *fileName, CHAR *key, SHORT uniq)
{
	PCCB	pCCB;
	struct	PRM_DB_IDX_CREATE	*pParam;
	SHORT	indexNo = 0;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBIdxCreate(pFCB->pDB, fileName, key, uniq, &indexNo);
	} else {
		if (strlen(fileName) >= sizeof(pParam->fileName)) {
			err = ERROR_CLIENT_PARAMETER;
			goto ret;
		}

		if (strlen(key) >= sizeof(pParam->key)) {
			err = ERROR_CLIENT_PARAMETER;
			goto ret;
		}

		pParam = (struct PRM_DB_IDX_CREATE *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;
		strcpy(pParam->fileName, fileName);
		strcpy(pParam->key, key);
		pParam->uniq = uniq;

		err = SendCommand(pCCB, FC_DB_IDX_CREATE,
					sizeof(struct PRM_DB_IDX_CREATE), 0);

		indexNo = pCCB->response.ret.sValue;
	}
ret:
	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}

	return indexNo;
}

/*=======================================================================
 |
 |		}X^[CfbNX؂ւ
 |
 |	VOID	PSDBChgIdx(pFCB)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |
 =======================================================================*/
VOID	PSENTRY PSDBChgIdx(PFCB pFCB, SHORT n)
{
	PCCB	pCCB;
	struct	PRM_DB_CHGIDX	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBChgIdx(pFCB->pDB, n);
	} else {
		pParam = (struct PRM_DB_CHGIDX *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;
		pParam->n = n;

		err = SendCommand(pCCB, FC_DB_CHGIDX,
					sizeof(struct PRM_DB_CHGIDX), 0);
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}
}

/*=======================================================================
 |
 |		CfbNXt@Cɂ錟iSvCOvj
 |
 |	VOID	PSDBSearch(pFCB, key, len)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |		CHAR	*key;		镶
 |		SHORT	len;		镶̒
 |
 =======================================================================*/
VOID	PSENTRY PSDBSearch(PFCB pFCB, CHAR *key, SHORT len)
{
	PCCB	pCCB;
	struct	PRM_DB_SEARCH	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBSearch(pFCB->pDB, key, len);
	} else {
		pParam = (struct PRM_DB_SEARCH *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;
		memcpy(pParam->key, key, len);
		pParam->len = len;

		err = SendCommand(pCCB, FC_DB_SEARCH,
					sizeof(struct PRM_DB_SEARCH), 0);
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}
}

/*=======================================================================
 |
 |		CfbNXt@Cɂ錟i͈͎wΉj
 |
 |	SHORT	PSDBSearch2(pFCB, key, len)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |		CHAR	*key;		镶
 |		SHORT	len;		镶̒
 |
 |		SHORT	Ԓl		
 |					OFYR[h
 |					PFv郌R[h
 |					QFv郌R[h͌Ȃ
 |
 =======================================================================*/
SHORT	PSENTRY PSDBSearch2(PFCB pFCB, CHAR *key, SHORT len)
{
	PCCB	pCCB;
	struct	PRM_DB_SEARCH2	*pParam;
	SHORT	find;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBSearch2(pFCB->pDB, key, len, &find);
	} else {
		pParam = (struct PRM_DB_SEARCH2 *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;
		memcpy(pParam->key, key, len);
		pParam->len = len;

		err = SendCommand(pCCB, FC_DB_SEARCH2,
					sizeof(struct PRM_DB_SEARCH2), 0);

		find = pCCB->response.ret.sValue;
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}

	return find;
}

/*=======================================================================
 |
 |		CfbNXt@Cɂ錟ibNtj
 |
 |	LONG	PSDBSearchLock(pFCB, key, len)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |		CHAR	*key;		镶
 |		SHORT	len;		镶̒
 |
 |		LONG	Ԓl		ꂽR[h
 |
 =======================================================================*/
LONG	PSENTRY PSDBSearchLock(PFCB pFCB, CHAR *key, SHORT len)
{
	PCCB	pCCB;
	struct	PRM_DB_SEARCHLOCK	*pParam;
	long	count;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBSearchLock(pFCB->pDB, key, len, &count);
	} else {
		pParam = (struct PRM_DB_SEARCHLOCK *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;
		memcpy(pParam->key, key, len);
		pParam->len = len;

		err = SendCommand(pCCB, FC_DB_SEARCHLOCK,
					sizeof(struct PRM_DB_SEARCHLOCK), 0);

		count = pCCB->response.ret.lValue;
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}

	return count;
}

/*=======================================================================
 |
 |		L[Ɉv郌R[h̎擾
 |
 |	LONG	PSDBCount(pFCB, key, len)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |		CHAR	*key;		镶
 |		SHORT	len;		镶̒
 |
 |		LONG	Ԓl		L[ɈvR[h
 |
 =======================================================================*/
LONG	PSENTRY PSDBCount(PFCB pFCB, CHAR *key, SHORT len)
{
	PCCB	pCCB;
	struct	PRM_DB_COUNT	*pParam;
	long	nRec;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBCount(pFCB->pDB, key, len, &nRec);
	} else {
		pParam = (struct PRM_DB_COUNT *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;
		memcpy(pParam->key, key, len);
		pParam->len = len;

		err = SendCommand(pCCB, FC_DB_COUNT,
					sizeof(struct PRM_DB_COUNT), 0);

		nRec = pCCB->response.ret.lValue;
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}

	return nRec;
}

/*=======================================================================
 |
 |		R[hǉ
 |
 |	VOID	PSDBStore(pFCB, rec)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |		CHAR	*rec;		ǉ郌R[hf[^ւ̃|C^
 |
 =======================================================================*/
VOID	PSENTRY PSDBStore(PFCB pFCB, CHAR *rec)
{
	PCCB	pCCB;
	struct	PRM_DB_STORE	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBStore(pFCB->pDB, rec);
	} else {
		pParam = (struct PRM_DB_STORE *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;

		pCCB->pInData = rec;

		err = SendCommand(pCCB, FC_DB_STORE,
					sizeof(struct PRM_DB_STORE),
					pFCB->DBInf.recSize);
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}
}

/*=======================================================================
 |
 |		R[hǉidj
 |
 |	VOID	PSDBStoreUniq(pFCB, rec)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |		CHAR	*rec;		ǉ郌R[hf[^ւ̃|C^
 |
 =======================================================================*/
VOID	PSENTRY PSDBStoreUniq(PFCB pFCB, CHAR *rec)
{
	PCCB	pCCB;
	struct	PRM_DB_STOREUNIQ	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBStoreUniq(pFCB->pDB, rec);
	} else {
		pParam = (struct PRM_DB_STOREUNIQ *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;

		pCCB->pInData = rec;

		err = SendCommand(pCCB, FC_DB_STOREUNIQ,
					sizeof(struct PRM_DB_STOREUNIQ),
					pFCB->DBInf.recSize);
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}
}

/*=======================================================================
 |
 |		R[hXV
 |
 |	VOID	PSDBUpdate(pFCB, rec)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |		CHAR	*rec;		XV郌R[hf[^ւ̃|C^
 |
 =======================================================================*/
VOID	PSENTRY PSDBUpdate(PFCB pFCB, CHAR *rec)
{
	PCCB	pCCB;
	struct	PRM_DB_UPDATE	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBUpdate(pFCB->pDB, rec);
	} else {
		pParam = (struct PRM_DB_UPDATE *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;

		pCCB->pInData = rec;

		err = SendCommand(pCCB, FC_DB_UPDATE,
					sizeof(struct PRM_DB_UPDATE),
					pFCB->DBInf.recSize);
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}
}

/*=======================================================================
 |
 |		L[wɂ郌R[hXV
 |
 |	VOID	PSDBUpdateKey(pFCB, key, len, buf)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |		CHAR	*key;		L[
 |		SHORT	len;		L[
 |		CHAR	*buf;		R[hobt@
 |
 =======================================================================*/
VOID	PSENTRY PSDBUpdateKey(PFCB pFCB, CHAR *key, SHORT len,
							CHAR *buf)
{
	PCCB	pCCB;
	struct	PRM_DB_UPDATEKEY	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBUpdateKey(pFCB->pDB, key, len, buf);
	} else {
		pParam = (struct PRM_DB_UPDATEKEY *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;
		memcpy(pParam->key, key, len);
		pParam->len = len;

		pCCB->pInData = buf;

		err = SendCommand(pCCB, FC_DB_UPDATEKEY,
					sizeof(struct PRM_DB_UPDATEKEY),
					pFCB->DBInf.recSize);
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}
}

/*=======================================================================
 |
 |		R[h폜
 |
 |	VOID	PSDBDelete(pFCB)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |
 =======================================================================*/
VOID	PSENTRY PSDBDelete(PFCB pFCB)
{
	PCCB	pCCB;
	struct	PRM_DB_DELETE	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBDelete(pFCB->pDB);
	} else {
		pParam = (struct PRM_DB_DELETE *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;

		err = SendCommand(pCCB, FC_DB_DELETE,
					sizeof(struct PRM_DB_DELETE), 0);
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}
}

/*=======================================================================
 |
 |		R[h
 |
 |	VOID	PSDBRecall(pFCB)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |
 =======================================================================*/
VOID	PSENTRY PSDBRecall(PFCB pFCB)
{
	PCCB	pCCB;
	struct	PRM_DB_RECALL	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBRecall(pFCB->pDB);
	} else {
		pParam = (struct PRM_DB_RECALL *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;

		err = SendCommand(pCCB, FC_DB_RECALL,
					sizeof(struct PRM_DB_RECALL), 0);
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}
}

/*=======================================================================
 |
 |		R[h̕I폜
 |
 |	VOID	PSDBDelete2(pFCB)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |
 =======================================================================*/
VOID	PSENTRY PSDBDelete2(PFCB pFCB)
{
	PCCB	pCCB;
	struct	PRM_DB_DELETE2	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBDelete2(pFCB->pDB);
	} else {
		pParam = (struct PRM_DB_DELETE2 *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;

		err = SendCommand(pCCB, FC_DB_DELETE2,
				sizeof(struct PRM_DB_DELETE2), 0);
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}
}

/*=======================================================================
 |
 |		R[h̕I폜iJgR[h|C^ۑj
 |
 |	VOID	PSDBDelete3(pFCB)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |
 =======================================================================*/
VOID	PSENTRY PSDBDelete3(PFCB pFCB)
{
	PCCB	pCCB;
	struct	PRM_DB_DELETE3	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBDelete3(pFCB->pDB);
	} else {
		pParam = (struct PRM_DB_DELETE3 *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;

		err = SendCommand(pCCB, FC_DB_DELETE3,
				sizeof(struct PRM_DB_DELETE3), 0);
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}
}

/*=======================================================================
 |
 |		L[wɂ郌R[h̕I폜
 |
 |	VOID	PSDBDeleteKey(pFCB, key, len, flag)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |		CHAR	*key;		폜L[
 |		SHORT	len;		L[̒
 |		SHORT	flag;		OFdL[̓G[
 |					PFdL[폜
 |
 =======================================================================*/
VOID	PSENTRY PSDBDeleteKey(PFCB pFCB, CHAR *key, SHORT len, SHORT flag)
{
	PCCB	pCCB;
	struct	PRM_DB_DELETEKEY	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBDeleteKey(pFCB->pDB, key, len, flag);
	} else {
		pParam = (struct PRM_DB_DELETEKEY *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;
		memcpy(pParam->key, key, len);
		pParam->len = len;
		pParam->flag = flag;

		err = SendCommand(pCCB, FC_DB_DELETEKEY,
				sizeof(struct PRM_DB_DELETEKEY), 0);
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}
}

/*=======================================================================
 |
 |		R[h|C^擪R[hɃZbg
 |
 |	VOID	PSDBTop(pFCB)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |
 =======================================================================*/
VOID	PSENTRY PSDBTop(PFCB pFCB)
{
	PCCB	pCCB;
	struct	PRM_DB_TOP	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBTop(pFCB->pDB);
	} else {
		pParam = (struct PRM_DB_TOP *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;

		err = SendCommand(pCCB, FC_DB_TOP,
					sizeof(struct PRM_DB_TOP), 0);
	}

	pFCB->readBufRecord = 0;

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}
}

/*=======================================================================
 |
 |		R[h|C^ŏIR[hɃZbg
 |
 |	VOID	PSDBBottom(pFCB)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |
 =======================================================================*/
VOID	PSENTRY PSDBBottom(PFCB pFCB)
{
	PCCB	pCCB;
	struct	PRM_DB_BOTTOM	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBBottom(pFCB->pDB);
	} else {
		pParam = (struct PRM_DB_BOTTOM *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;

		err = SendCommand(pCCB, FC_DB_BOTTOM,
					sizeof(struct PRM_DB_BOTTOM), 0);
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}
}

/*=======================================================================
 |
 |		R[h|C^w肳ꂽR[hɃZbg
 |
 |	VOID	PSDBSet(pFCB, recNo)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |		LONG	recNo;		R[hԍ
 |
 =======================================================================*/
VOID	PSENTRY PSDBSet(PFCB pFCB, long recNo)
{
	PCCB	pCCB;
	struct	PRM_DB_SET	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBSet(pFCB->pDB, recNo);
	} else {
		pParam = (struct PRM_DB_SET *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;
		pParam->recNo = recNo;

		err = SendCommand(pCCB, FC_DB_SET,
					sizeof(struct PRM_DB_SET), 0);
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}
}

/*=======================================================================
 |
 |		R[h|C^̑Oړ
 |
 |	VOID	PSDBSkip(pFCB, n)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |		LONG	n;		ړR[h
 |
 =======================================================================*/
VOID	PSENTRY PSDBSkip(PFCB pFCB, long n)
{
	PCCB	pCCB;
	struct	PRM_DB_SKIP	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBSkip(pFCB->pDB, n);
	} else {
		pParam = (struct PRM_DB_SKIP *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;
		pParam->n = n;

		err = SendCommand(pCCB, FC_DB_SKIP,
					sizeof(struct PRM_DB_SKIP), 0);
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}
}

/*=======================================================================
 |
 |		CfbNXt@Cč\z
 |
 |	VOID	PSDBReindex(pFCB)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |
 =======================================================================*/
VOID	PSENTRY PSDBReindex(PFCB pFCB)
{
	PCCB	pCCB;
	struct	PRM_DB_REINDEX	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBReindex(pFCB->pDB);
	} else {
		pParam = (struct PRM_DB_REINDEX *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;

		err = SendCommand(pCCB, FC_DB_REINDEX,
					sizeof(struct PRM_DB_REINDEX), 0);
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}
}

/*=======================================================================
 |
 |		폜R[ht@Cォ폜
 |
 |	VOID	PSDBPack(pFCB)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |
 =======================================================================*/
VOID	PSENTRY PSDBPack(PFCB pFCB)
{
	PCCB	pCCB;
	struct	PRM_DB_PACK	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBPack(pFCB->pDB);
	} else {
		pParam = (struct PRM_DB_PACK *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;

		err = SendCommand(pCCB, FC_DB_PACK,
					sizeof(struct PRM_DB_PACK), 0);
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}
}

/*=======================================================================
 |
 |		JgR[hǂݍ
 |
 |	VOID	PSDBRead(pFCB, pBuf)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |		CHAR	*pBuf;		R[hǂݍ݃obt@|C^
 |
 =======================================================================*/
VOID	PSENTRY PSDBRead(PFCB pFCB, CHAR *pBuf)
{
	PCCB	pCCB;
	struct	PRM_DB_READ	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBRead(pFCB->pDB, pBuf);
	} else {
		pParam = (struct PRM_DB_READ *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;

		pCCB->pOutData = pBuf;

		err = SendCommand(pCCB, FC_DB_READ,
					sizeof(struct PRM_DB_READ), 0);
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}
}

/*=======================================================================
 |
 |		R[hR[hǂݍ
 |
 |	SHORT	PSDBReadNext(pFCB, nRec, pBuf)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |		SHORT	nRec;		R[h
 |		CHAR	*pBuf;		R[hǂݍ݃obt@|C^
 |
 |		SHORT	Ԓl		ۂɓǂ񂾃R[h
 |
 =======================================================================*/
SHORT	PSENTRY PSDBReadNext(PFCB pFCB, SHORT nRec, CHAR *pBuf)
{
	PCCB	pCCB;
	struct	PRM_DB_READNEXT	*pParam;
	SHORT	readRec;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBReadNext(pFCB->pDB, nRec, pBuf, &readRec);
	} else {
		pParam = (struct PRM_DB_READNEXT *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;
		pParam->nRec = nRec;
		pCCB->pOutData = pBuf;

		err = SendCommand(pCCB, FC_DB_READNEXT,
				sizeof(struct PRM_DB_READNEXT), 0);

		readRec = pCCB->response.ret.sValue;
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}

	return readRec;
}

/*=======================================================================
 |
 |		OR[hR[hǂݍ
 |
 |	SHORT	PSDBReadBack(pFCB, nRec, pBuf)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |		SHORT	nRec;		R[h
 |		CHAR	*pBuf;		R[hǂݍ݃obt@|C^
 |
 |		SHORT	Ԓl		ۂɓǂ񂾃R[h
 |
 =======================================================================*/
SHORT	PSENTRY PSDBReadBack(PFCB pFCB, SHORT nRec, CHAR *pBuf)
{
	PCCB	pCCB;
	struct	PRM_DB_READBACK	*pParam;
	SHORT	readRec;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBReadBack(pFCB->pDB, nRec, pBuf, &readRec);
	} else {
		pParam = (struct PRM_DB_READBACK *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;
		pParam->nRec = nRec;

		pCCB->pOutData = pBuf;
		err = SendCommand(pCCB, FC_DB_READBACK,
				sizeof(struct PRM_DB_READBACK), 0);

		readRec = pCCB->response.ret.sValue;
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}

	return readRec;
}

/*=======================================================================
 |
 |		L[wɂ郌R[hǂݍ
 |
 |	SHORT	PSDBReadKey(pFCB, key, len, buf, lock)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |		CHAR	*key;		L[
 |		SHORT	len;		L[
 |		CHAR	*buf;		R[hobt@
 |		SHORT	lock;		OFR[hbNȂ@PF
 |
 |		SHORT	Ԓl		OFYR[hȂ@PF
 |
 =======================================================================*/
SHORT	PSENTRY PSDBReadKey(PFCB pFCB, CHAR *key, SHORT len, CHAR *buf,
								SHORT lock)
{
	PCCB	pCCB;
	struct	PRM_DB_READKEY	*pParam;
	SHORT	flag;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBReadKey(pFCB->pDB, key, len, buf, lock, &flag);
	} else {
		pParam = (struct PRM_DB_READKEY *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;
		memcpy(pParam->key, key, len);
		pParam->len = len;
		pParam->lock = lock;

		pCCB->pOutData = buf;

		err = SendCommand(pCCB, FC_DB_READKEY,
					sizeof(struct PRM_DB_READKEY), 0);

		flag = pCCB->response.ret.sValue;
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}

	return flag;
}

/*=======================================================================
 |
 |		R[hobt@NA
 |
 |	VOID	PSDBClrRecord(pFCB)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |
 =======================================================================*/
VOID	PSENTRY PSDBClrRecord(PFCB pFCB)
{
	PCCB	pCCB;
	struct	PRM_DB_CLRRECORD	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBClrRecord(pFCB->pDB);
	} else {
		pParam = (struct PRM_DB_CLRRECORD *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;

		err = SendCommand(pCCB, FC_DB_CLRRECORD,
					sizeof(struct PRM_DB_CLRRECORD), 0);
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}
}

/*=======================================================================
 |
 |		R[hobt@ǂݍ
 |
 |	VOID	PSDBGetRecord(pFCB)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |
 =======================================================================*/
VOID	PSENTRY PSDBGetRecord(PFCB pFCB)
{
	PCCB	pCCB;
	struct	PRM_DB_GETRECORD	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBGetRecord(pFCB->pDB);
	} else {
		pParam = (struct PRM_DB_GETRECORD *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;

		err = SendCommand(pCCB, FC_DB_GETRECORD,
					sizeof(struct PRM_DB_GETRECORD), 0);
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}
}

/*=======================================================================
 |
 |		tB[hf[^ǂݍ
 |
 |	SHORT	PSDBGetField(pFCB, field, pBuf)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |		CHAR	*field;		tB[h
 |		VOID	*pBuf;		tB[hobt@
 |
 |		SHORT	Ԓl		tB[ȟ^
 |
 =======================================================================*/
SHORT	PSENTRY PSDBGetField(PFCB pFCB, CHAR *field, VOID *pBuf)
{
	PCCB	pCCB;
	struct	PRM_DB_GETFIELD	*pParam;
	SHORT	fieldType = 0;
	SHORT	dataSize;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBGetField(pFCB->pDB, field, pBuf, &fieldType,
								&dataSize);
	} else {
		if (strlen(field) >= sizeof(pParam->field)) {
			err = ERROR_CLIENT_PARAMETER;
			goto ret;
		}

		pParam = (struct PRM_DB_GETFIELD *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;
		strcpy(pParam->field, field);

		pCCB->pOutData = pBuf;

		err = SendCommand(pCCB, FC_DB_GETFIELD,
					sizeof(struct PRM_DB_GETFIELD), 0);

		fieldType = pCCB->response.ret.sValue;
	}
ret:
	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}

	return fieldType;
}

/*=======================================================================
 |
 |		tB[hf[^
 |
 |	VOID	PSDBSetField(pFCB, field, pBuf)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |		CHAR	*field;		tB[h
 |		VOID	*pBuf;		tB[hobt@
 |
 =======================================================================*/
VOID	PSENTRY PSDBSetField(PFCB pFCB, CHAR *field, VOID *pBuf)
{
	PCCB	pCCB;
	struct	PRM_DB_SETFIELD	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBSetField(pFCB->pDB, field, pBuf);
	} else {
		if (strlen(field) >= sizeof(pParam->field)) {
			err = ERROR_CLIENT_PARAMETER;
			goto ret;
		}

		pParam = (struct PRM_DB_SETFIELD *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;
		strcpy(pParam->field, field);

		pCCB->pInData = pBuf;

		err = SendCommand(pCCB, FC_DB_SETFIELD,
					sizeof(struct PRM_DB_SETFIELD), 255);
	}
ret:
	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}
}

/*=======================================================================
 |
 |		R[hǉ
 |
 |	VOID	PSDBAddRecord(pFCB)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |
 =======================================================================*/
VOID	PSENTRY PSDBAddRecord(PFCB pFCB)
{
	PCCB	pCCB;
	struct	PRM_DB_ADDRECORD	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBAddRecord(pFCB->pDB);
	} else {
		pParam = (struct PRM_DB_ADDRECORD *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;

		err = SendCommand(pCCB, FC_DB_ADDRECORD,
					sizeof(struct PRM_DB_ADDRECORD), 0);
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}
}

/*=======================================================================
 |
 |		R[hXV
 |
 |	VOID	PSDBUpdRecord(pFCB)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |
 =======================================================================*/
VOID	PSENTRY PSDBUpdRecord(PFCB pFCB)
{
	PCCB	pCCB;
	struct	PRM_DB_UPDRECORD	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBUpdRecord(pFCB->pDB);
	} else {
		pParam = (struct PRM_DB_UPDRECORD *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;

		err = SendCommand(pCCB, FC_DB_UPDRECORD,
					sizeof(struct PRM_DB_UPDRECORD), 0);
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}
}

/*=======================================================================
 |
 |		f[^t@C̃Rs[
 |
 |	VOID	PSDBCopy(pFCB1, pFCB2)
 |
 |		PFCB	pFCB1;		Rs[t@CubN|C^
 |		PFCB	pFCB2;		Rs[t@CubN|C^
 |
 =======================================================================*/
VOID	PSENTRY PSDBCopy(PFCB pFCB1, PFCB pFCB2)
{
	PCCB	pCCB;
	struct	PRM_DB_COPY	*pParam;
	SHORT	err;

	pCCB = pFCB1->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBCopy(pFCB1->pDB, pFCB2->pDB);
	} else {
		pParam = (struct PRM_DB_COPY *)pCCB->command.param;
		pParam->handle1 = pFCB1->fileHandle;
		pParam->handle2 = pFCB2->fileHandle;

		err = SendCommand(pCCB, FC_DB_COPY,
					sizeof(struct PRM_DB_COPY), 0);
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB1->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB1, err);
	}
}

/*=======================================================================
 |
 |		폜R[h`FbN
 |
 |	SHORT	PSDBCheckDeleted(pFCB)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |
 |		SHORT	Ԓl		OFʏ탌R[h@PF폜R[h
 |
 =======================================================================*/
SHORT	PSENTRY PSDBCheckDeleted(PFCB pFCB)
{
	PCCB	pCCB;
	struct	PRM_DB_CHECK_DELETED	*pParam;
	SHORT	flag;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBCheckDeleted(pFCB->pDB, &flag);
	} else {
		pParam = (struct PRM_DB_CHECK_DELETED *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;

		err = SendCommand(pCCB, FC_DB_CHECK_DELETED,
				sizeof(struct PRM_DB_CHECK_DELETED), 0);

		flag = pCCB->response.ret.sValue;
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}

	return flag;
}

/*=======================================================================
 |
 |		tB^ݒ
 |
 |	VOID	PSDBSetFilter(pFCB, filter)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |		CHAR	*filter;	tB^
 |
 =======================================================================*/
VOID	PSENTRY PSDBSetFilter(PFCB pFCB, CHAR *filter)
{
	PCCB	pCCB;
	struct	PRM_DB_SET_FILTER	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBSetFilter(pFCB->pDB, filter);
	} else {
		pParam = (struct PRM_DB_SET_FILTER *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;
		if (filter != NULL)
			pCCB->pInData = filter;
		else
			pCCB->pInData = "";

		err = SendCommand(pCCB, FC_DB_SET_FILTER,
				sizeof(struct PRM_DB_SET_FILTER),
				strlen(pCCB->pInData) + 1);
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}
}

/*=======================================================================
 |
 |		Iݒ
 |
 |	LONG	PSDBSelect(pFCB, select)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |		CHAR	*select;	I
 |
 |		LONG	Ԓl		IR[h
 |
 =======================================================================*/
LONG	PSENTRY PSDBSelect(PFCB pFCB, CHAR *select)
{
	PCCB	pCCB;
	struct	PRM_DB_SELECT	*pParam;
	LONG	nRec = 0;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBSelect(pFCB->pDB, select, &nRec);
	} else {
		pParam = (struct PRM_DB_SELECT *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;
		if (select != NULL)
			pCCB->pInData = select;
		else
			pCCB->pInData = "";

		err = SendCommand(pCCB, FC_DB_SELECT,
				sizeof(struct PRM_DB_SELECT),
				strlen(pCCB->pInData) + 1);

		if (err == 0)
			nRec = pCCB->response.ret.lValue;
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}

	return nRec;
}

/*=======================================================================
 |
 |		폜R[hL^̐ݒ
 |
 |	VOID	PSDBSetDeleted(pFCB, flag)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |		SHORT	flag;		OF폜R[hL
 |					PF폜R[h
 |
 =======================================================================*/
VOID	PSENTRY PSDBSetDeleted(PFCB pFCB, SHORT flag)
{
	PCCB	pCCB;
	struct	PRM_DB_SET_DELETED	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBSetDeleted(pFCB->pDB, flag);
	} else {
		pParam = (struct PRM_DB_SET_DELETED *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;
		pParam->flag = flag;

		err = SendCommand(pCCB, FC_DB_SET_DELETED,
				sizeof(struct PRM_DB_SET_DELETED), 0);
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}
}

/*=======================================================================
 |
 |		JgR[h̘_R[hԍo
 |
 |	LONG	PSDBLRecNo(pFCB)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |
 |		LONG	Ԓl		_R[hԍ
 |
 =======================================================================*/
LONG	PSENTRY PSDBLRecNo(PFCB pFCB)
{
	PCCB	pCCB;
	struct	PRM_DB_LRECNO	*pParam;
	long	recNo;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBLRecNo(pFCB->pDB, &recNo);
	} else {
		pParam = (struct PRM_DB_LRECNO *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;

		err = SendCommand(pCCB, FC_DB_LRECNO,
					sizeof(struct PRM_DB_LRECNO), 0);

		recNo = pCCB->response.ret.lValue;
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}

	return recNo;
}

/*=======================================================================
 |
 |		_R[ho
 |
 |	LONG	PSDBLRecCount(pFCB)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |
 |		LONG	Ԓl		_R[h
 |
 =======================================================================*/
LONG	PSENTRY PSDBLRecCount(PFCB pFCB)
{
	PCCB	pCCB;
	struct	PRM_DB_LRECCOUNT	*pParam;
	long	nRec;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBLRecCount(pFCB->pDB, &nRec);
	} else {
		pParam = (struct PRM_DB_LRECCOUNT *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;

		err = SendCommand(pCCB, FC_DB_LRECCOUNT,
					sizeof(struct PRM_DB_LRECCOUNT), 0);

		nRec = pCCB->response.ret.lValue;
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}

	return nRec;
}

/*=======================================================================
 |
 |		_R[hԍɂJgR[h̐ݒ
 |
 |	VOID	PSDBLSet(pFCB, lRecNo)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |		LONG	lRecNo;		_R[hԍ
 |
 =======================================================================*/
VOID	PSENTRY PSDBLSet(PFCB pFCB, LONG lRecNo)
{
	PCCB	pCCB;
	struct	PRM_DB_LSET	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBLSet(pFCB->pDB, lRecNo);
	} else {
		pParam = (struct PRM_DB_LSET *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;
		pParam->lRecNo = lRecNo;

		err = SendCommand(pCCB, FC_DB_LSET,
					sizeof(struct PRM_DB_LSET), 0);
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}
}

/*=======================================================================
 |
 |		SR[h폜
 |
 |	VOID	PSDBZip(pFCB)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |
 =======================================================================*/
VOID	PSENTRY PSDBZip(PFCB pFCB)
{
	PCCB	pCCB;
	struct	PRM_DB_ZIP	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBZip(pFCB->pDB);
	} else {
		pParam = (struct PRM_DB_ZIP *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;

		err = SendCommand(pCCB, FC_DB_ZIP,
					sizeof(struct PRM_DB_ZIP), 0);
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}
}

/*=======================================================================
 |
 |		XV`FbN
 |
 |	SHORT	PSDBCheckUpdate(pFCB)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |
 |		SHORT	Ԓl		OFXVȂ@PFXV
 |
 =======================================================================*/
SHORT	PSENTRY PSDBCheckUpdate(PFCB pFCB)
{
	PCCB	pCCB;
	struct	PRM_DB_CHECK_UPDATE	*pParam;
	SHORT	updateFlag;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBCheckUpdate(pFCB->pDB, &updateFlag);
	} else {
		pParam = (struct PRM_DB_CHECK_UPDATE *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;

		err = SendCommand(pCCB, FC_DB_CHECK_UPDATE,
					sizeof(struct PRM_DB_CHECK_UPDATE), 0);

		updateFlag = pCCB->response.ret.sValue;
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}

	return updateFlag;
}

/*=======================================================================
 |
 |		t@C^R[hbN
 |
 |	VOID	PSDBLock(pFCB, lock)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |		SHORT	lock;		OFt@CbN@PFR[hbN
 |
 =======================================================================*/
VOID	PSENTRY PSDBLock(PFCB pFCB, SHORT lock)
{
	PCCB	pCCB;
	struct	PRM_DB_LOCK	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBLock(pFCB->pDB, lock);
	} else {
		pParam = (struct PRM_DB_LOCK *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;
		pParam->lock = lock;

		err = SendCommand(pCCB, FC_DB_LOCK,
					sizeof(struct PRM_DB_LOCK), 0);
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}
}

/*=======================================================================
 |
 |		t@C^R[hbN
 |
 |	VOID	PSDBUnlock(pFCB, lock)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |		SHORT	lock;		OFt@CbN@PFR[hbN
 |
 =======================================================================*/
VOID	PSENTRY PSDBUnlock(PFCB pFCB, SHORT lock)
{
	PCCB	pCCB;
	struct	PRM_DB_UNLOCK	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBUnlock(pFCB->pDB, lock);
	} else {
		pParam = (struct PRM_DB_UNLOCK *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;
		pParam->lock = lock;

		err = SendCommand(pCCB, FC_DB_UNLOCK,
					sizeof(struct PRM_DB_UNLOCK), 0);
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}
}

/*=======================================================================
 |
 |		R[ho
 |
 |	LONG	PSDBRecCount(pFCB)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |
 |		LONG	Ԓl		R[h
 |
 =======================================================================*/
LONG	PSENTRY PSDBRecCount(PFCB pFCB)
{
	PCCB	pCCB;
	struct	PRM_DB_RECCOUNT	*pParam;
	long	nRec;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBRecCount(pFCB->pDB, &nRec);
	} else {
		pParam = (struct PRM_DB_RECCOUNT *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;

		err = SendCommand(pCCB, FC_DB_RECCOUNT,
					sizeof(struct PRM_DB_RECCOUNT), 0);

		nRec = pCCB->response.ret.lValue;
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}

	return nRec;
}

/*=======================================================================
 |
 |		ane`FbN
 |
 |	SHORT	PSDBBof(pFCB)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |
 |		SHORT	Ԓl		OFanełȂ@PFane
 |
 =======================================================================*/
SHORT	PSENTRY PSDBBof(PFCB pFCB)
{
	PCCB	pCCB;
	struct	PRM_DB_BOF	*pParam;
	SHORT	bof;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBBof(pFCB->pDB, &bof);
	} else {
		pParam = (struct PRM_DB_BOF *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;

		err = SendCommand(pCCB, FC_DB_BOF,
					sizeof(struct PRM_DB_BOF), 0);

		bof = pCCB->response.ret.sValue;
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}

	return bof;
}

/*=======================================================================
 |
 |		f[^t@Co
 |
 |	VOID	PSDBDbf(pFCB, fileName)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |		CHAR	*fileName;	f[^t@C
 |
 =======================================================================*/
VOID	PSENTRY PSDBDbf(PFCB pFCB, CHAR *fileName)
{
	PCCB	pCCB;
	struct	PRM_DB_DBF	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBDbf(pFCB->pDB, fileName);
	} else {
		pParam = (struct PRM_DB_DBF *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;

		pCCB->pOutData = fileName;

		err = SendCommand(pCCB, FC_DB_DBF,
					sizeof(struct PRM_DB_DBF), 0);
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}
}

/*=======================================================================
 |
 |		dne`FbN
 |
 |	SHORT	PSDBEof(pFCB)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |
 |		SHORT	Ԓl		OFdnełȂ@PFdne
 |
 =======================================================================*/
SHORT	PSENTRY PSDBEof(PFCB pFCB)
{
	PCCB	pCCB;
	struct	PRM_DB_EOF	*pParam;
	SHORT	eof;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBEof(pFCB->pDB, &eof);
	} else {
		pParam = (struct PRM_DB_EOF *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;

		err = SendCommand(pCCB, FC_DB_EOF,
					sizeof(struct PRM_DB_EOF), 0);

		eof = pCCB->response.ret.sValue;
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}

	return eof;
}

/*=======================================================================
 |
 |		tB[h擾
 |
 |	SHORT	PSDBNField(pFCB)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |
 |		SHORT	Ԓl		tB[h
 |
 =======================================================================*/
SHORT	PSENTRY PSDBNField(PFCB pFCB)
{
	PCCB	pCCB;
	struct	PRM_DB_NFIELD	*pParam;
	SHORT	nField;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBNField(pFCB->pDB, &nField);
	} else {
		pParam = (struct PRM_DB_NFIELD *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;

		err = SendCommand(pCCB, FC_DB_NFIELD,
					sizeof(struct PRM_DB_NFIELD), 0);

		nField = pCCB->response.ret.sValue;
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}

	return nField;
}

/*=======================================================================
 |
 |		tB[ho
 |
 |	VOID	PSDBField(pFCB, n, dip)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |		SHORT	n;		tB[hԍ
 |		PDBF_I	dip;		tB[h
 |
 =======================================================================*/
VOID	PSENTRY PSDBField(PFCB pFCB, SHORT n, PDBF_I dip)
{
	PCCB	pCCB;
	struct	PRM_DB_FIELD	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBField(pFCB->pDB, n, dip);
	} else {
		pParam = (struct PRM_DB_FIELD *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;
		pParam->n = n;

		pCCB->pOutData = dip;

		err = SendCommand(pCCB, FC_DB_FIELD,
					sizeof(struct PRM_DB_FIELD), 0);
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}
}

/*=======================================================================
 |
 |		CfbNXt@Co
 |
 |	VOID	PSDBNdx(pFCB, n, fileName)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |		SHORT	n;		CfbNXt@Cԍ
 |		CHAR	*fileName;	CfbNXt@C
 |
 =======================================================================*/
VOID	PSENTRY PSDBNdx(PFCB pFCB, SHORT n, CHAR *fileName)
{
	PCCB	pCCB;
	struct	PRM_DB_NDX	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBNdx(pFCB->pDB, n, fileName);
	} else {
		pParam = (struct PRM_DB_NDX *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;
		pParam->n = n;

		pCCB->pOutData = fileName;

		err = SendCommand(pCCB, FC_DB_NDX,
					sizeof(struct PRM_DB_NDX), 0);
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}
}

/*=======================================================================
 |
 |		JgR[hԍo
 |
 |	LONG	PSDBRecNo(pFCB)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |
 |		LONG	Ԓl		JgR[hԍ
 |
 =======================================================================*/
LONG	PSENTRY PSDBRecNo(PFCB pFCB)
{
	PCCB	pCCB;
	struct	PRM_DB_RECNO	*pParam;
	long	recNo;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBRecNo(pFCB->pDB, &recNo);
	} else {
		pParam = (struct PRM_DB_RECNO *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;

		err = SendCommand(pCCB, FC_DB_RECNO,
					sizeof(struct PRM_DB_RECNO), 0);

		recNo = pCCB->response.ret.lValue;
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}

	return recNo;
}

/*=======================================================================
 |
 |		R[ho
 |
 |	SHORT	PSDBRecSize(pFCB)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |
 |		SHORT	Ԓl		R[h
 |
 =======================================================================*/
SHORT	PSENTRY PSDBRecSize(PFCB pFCB)
{
	PCCB	pCCB;
	struct	PRM_DB_RECSIZE	*pParam;
	SHORT	recSize;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBRecSize(pFCB->pDB, &recSize);
	} else {
		pParam = (struct PRM_DB_RECSIZE *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;

		err = SendCommand(pCCB, FC_DB_RECSIZE,
					sizeof(struct PRM_DB_RECSIZE), 0);

		recSize = pCCB->response.ret.sValue;
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}

	return recSize;
}

/*=======================================================================
 |
 |		ŐVG[R[h擾
 |
 |	SHORT	PSDBGetErrCode(pFCB)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |
 |		SHORT	Ԓl		G[R[h
 |
 =======================================================================*/
SHORT	PSENTRY PSDBGetErrCode(PFCB pFCB)
{
	SHORT	err;

	err = pFCB->errorCode;
	pFCB->errorCode = 0;

	return err;
}

/*=======================================================================
 |
 |		G[nhݒ
 |
 |	VOID	PSDBSetErrHandler(pFCB, func)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |		VOID (*func)(PFCB, SHORT) G[nh֐
 |
 =======================================================================*/
VOID	PSENTRY PSDBSetErrHandler(PCCB pCCB, VOID (*func)(PFCB, SHORT))
{
	pCCB->pErrHandler = func;
}

VOID	PSENTRY	PSDBAsync(PCCB pCCB)
{
	pCCB->async = TRUE;
}

/*=======================================================================
 |
 |		Visual Basic pR[hǂݍ
 |
 |	SHORT	PSDBReadVB(pFCB, topIndex, nRec, hAD)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |		SHORT	topIndex;	擪Y
 |		SHORT	nRec;		ǂݍ݃R[h
 |		VOID	*hAD;		z̃nh
 |
 |		SHORT	Ԓl		ۂɓǂݍ݂R[h
 |
 =======================================================================*/
SHORT	PSENTRY PSDBReadVB(PFCB pFCB, SHORT topIndex, SHORT nRec, VOID *hAD)
{
#if defined OS_WINDOWS
#define	BUFSIZE	(1024*32U)
extern	LPVOID FAR PASCAL VBArrayElement(VOID *, SHORT, SHORT *);
	PCCB	pCCB;
	struct	PRM_DB_READNEXT	*pParam;
	CHAR	*buf;
	SHORT	nRead, n, readRec;
	LPVOID	lpData;
	SHORT	indexes[1];
	int	i;
	SHORT	err = 0;

	pCCB = pFCB->pCCB;

	readRec = 0;

	if ((buf = malloc(BUFSIZE)) == NULL) {
		err = ERROR_CLIENT_MEMORY;
		goto err;
	}

	indexes[0] = topIndex;
	for (;;) {
		nRead = min((USHORT)(nRec - readRec),
				(USHORT)BUFSIZE / pFCB->readSize);

		if (pCCB->chType == CHT_LOCAL) {
			err = DBReadNext(pFCB->pDB, nRead, buf, &n);
		} else {
			pParam = (struct PRM_DB_READNEXT *)pCCB->command.param;
			pParam->handle = pFCB->fileHandle;
			pParam->nRec = nRead;
			pCCB->pOutData = buf;
			err = SendCommand(pCCB, FC_DB_READNEXT,
					sizeof(struct PRM_DB_READNEXT), 0);

			n = pCCB->response.ret.sValue;
		}

		if (err != 0)
			break;

		for (i = 0; i < n; i++) {
			lpData = VBArrayElement(hAD, 1, indexes);
			if (HIWORD(lpData) == 0) {
				err = ERROR_DB_PARAMETER;
				break;
			}
			_fmemcpy(lpData, &buf[i * (USHORT)pFCB->readSize],
							pFCB->readSize);
			indexes[0]++;
		}

		readRec += n;

		if (err != 0 || n != nRead || readRec == nRec)
			break;
	}

	free(buf);
err:
	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}

	return readRec;
#elif defined OS_WNT
/*
#define	BUFSIZE	(1024*32U)
	PCCB	pCCB;
	struct	PRM_DB_READNEXT	*pParam;
	SAFEARRAY *psa;
	CHAR	*buf;
	USHORT	*wbuf;
	SHORT	nRead, n, readRec;
	int	i;
	int	elementSize;
	int	indexes[1];
	SHORT	err;

	pCCB = pFCB->pCCB;
	psa = *(SAFEARRAY **)hAD;

	readRec = 0;

	if ((buf = malloc(BUFSIZE)) == NULL) {
		err = ERROR_CLIENT_MEMORY;
		goto err;
	}

	elementSize = SafeArrayGetElemsize(psa);
	if ((wbuf = malloc(elementSize)) == NULL) {
		free(buf);
		err = ERROR_CLIENT_MEMORY;
		goto err;
	}

	indexes[0] = topIndex;
	for (;;) {
		nRead = min((USHORT)(nRec - readRec),
				(USHORT)BUFSIZE / pFCB->readSize);

		if (pCCB->chType == CHT_LOCAL) {
			err = DBReadNext(pFCB->pDB, nRead, buf, &n);
		} else {
			pParam = (struct PRM_DB_READNEXT *)pCCB->command.param;
			pParam->handle = pFCB->fileHandle;
			pParam->nRec = nRead;
			pCCB->pOutData = buf;
			err = SendCommand(pCCB, FC_DB_READNEXT,
					sizeof(struct PRM_DB_READNEXT), 0);

			n = pCCB->response.ret.sValue;
		}

		if (err != 0)
			break;

		for (i = 0; i < n; i++) {
			MultiByteToWideChar(CP_ACP, 0,
				(LPCSTR)&buf[i * (USHORT)pFCB->readSize],
					pFCB->readSize, (LPWSTR)wbuf,
					elementSize);
			SafeArrayPutElement(psa, indexes, wbuf);
			indexes[0]++;
		}

		readRec += n;

		if (err != 0 || n != nRead || readRec == nRec)
			break;
	}

	free(wbuf);
	free(buf);
err:
	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}

	return readRec;
*/
#define	BUFSIZE	(1024*32U)
	PCCB	pCCB;
	struct	PRM_DB_READNEXT	*pParam;
	SAFEARRAY *psa;
	CHAR	*buf;
	SHORT	nRead, n, readRec;
	int	i;
	int	indexes[1];
	SHORT	err;

	pCCB = pFCB->pCCB;
	psa = *(SAFEARRAY **)hAD;

	readRec = 0;

	if ((buf = malloc(BUFSIZE)) == NULL) {
		err = ERROR_CLIENT_MEMORY;
		goto err;
	}

	indexes[0] = topIndex;
	for (;;) {
		nRead = min((USHORT)(nRec - readRec),
				(USHORT)BUFSIZE / pFCB->readSize);

		if (pCCB->chType == CHT_LOCAL) {
			err = DBReadNext(pFCB->pDB, nRead, buf, &n);
		} else {
			pParam = (struct PRM_DB_READNEXT *)pCCB->command.param;
			pParam->handle = pFCB->fileHandle;
			pParam->nRec = nRead;
			pCCB->pOutData = buf;
			err = SendCommand(pCCB, FC_DB_READNEXT,
					sizeof(struct PRM_DB_READNEXT), 0);

			n = pCCB->response.ret.sValue;
		}

		if (err != 0)
			break;

		for (i = 0; i < n; i++) {
			SafeArrayPutElement(psa, indexes,
					&buf[i * (USHORT)pFCB->readSize]);
			indexes[0]++;
		}

		readRec += n;

		if (err != 0 || n != nRead || readRec == nRec)
			break;
	}

	free(buf);
err:
	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}

	return readRec;
#else
	PCCB	pCCB;
	SHORT	err;

	pCCB = pFCB->pCCB;
	err = ERROR_DB_NOSUPPORT;
	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}

	return 0;
#endif
}

/*=======================================================================
 |
 |		ǂݍ݃tB[hݒ
 |
 |	SHORT	PSDBSetReadField(pFCB, readField)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |		CHAR	*readField;	ǂݍ݃tB[h
 |
 |		SHORT	Ԓl		f[^
 |
 =======================================================================*/
SHORT	PSENTRY PSDBSetReadField(PFCB pFCB, CHAR *readField)
{
	PCCB	pCCB;
	struct	PRM_DB_SET_READFIELD	*pParam;
	SHORT	length;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBSetReadField(pFCB->pDB, readField, &length);
	} else {
		pParam = (struct PRM_DB_SET_READFIELD *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;
		if (readField != NULL)
			pCCB->pInData = readField;
		else
			pCCB->pInData = "";

		err = SendCommand(pCCB, FC_DB_SET_READFIELD,
				sizeof(struct PRM_DB_SET_READFIELD),
				strlen(pCCB->pInData) + 1);

		length = pCCB->response.ret.sValue;
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}

	pFCB->readSize = length;

	return length;
}

/*=======================================================================
 |
 |		ÍL[ݒ
 |
 |	VOID	PSDBSetScramble(pFCB)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |
 =======================================================================*/
VOID	PSENTRY PSDBSetScramble(PFCB pFCB)
{
	PCCB	pCCB;
	struct	PRM_DB_SET_SCRAMBLE	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBSetScramble(pFCB->pDB);
	} else {
		pParam = (struct PRM_DB_SET_SCRAMBLE *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;

		err = SendCommand(pCCB, FC_DB_SET_SCRAMBLE,
					sizeof(struct PRM_DB_SET_SCRAMBLE), 0);
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}
}

/*=======================================================================
 |
 |		pX[hݒ
 |
 |	VOID	PSDBSetPassword(pFCB)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |		CHAR	*password;	pX[h
 |
 =======================================================================*/
VOID	PSENTRY PSDBSetPassword(PFCB pFCB, CHAR *password)
{
	PCCB	pCCB;
	struct	PRM_DB_SET_PASSWORD	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBSetPassword(pFCB->pDB, password);
	} else {
		if (strlen(password) >= sizeof(pParam->password)) {
			err = ERROR_CLIENT_PARAMETER;
			goto ret;
		}

		pParam = (struct PRM_DB_SET_PASSWORD *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;
		strcpy(pParam->password, password);

		err = SendCommand(pCCB, FC_DB_SET_PASSWORD,
					sizeof(struct PRM_DB_SET_PASSWORD), 0);
	}
ret:
	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}
}

/*=======================================================================
 |
 |		ORACLE ptB[hXV
 |
 |	VOID	PSDBUpdateOracle(pFCB, key, buf)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |		CHAR	*key;		L[
 |		CHAR	*buf;		tB[hf[^
 |
 =======================================================================*/
VOID	PSENTRY PSDBUpdateOracle(PFCB pFCB, CHAR *key, CHAR *buf)
{
	PCCB	pCCB;
	struct	PRM_DB_UPDATEORACLE	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = ERROR_CLIENT_NOSUPPORT;
	} else {
		if (strlen(key) >= sizeof(pParam->key)) {
			err = ERROR_CLIENT_PARAMETER;
			goto ret;
		}

		pParam = (struct PRM_DB_UPDATEORACLE *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;
		strcpy(pParam->key, key);

		pCCB->pInData = buf;

		err = SendCommand(pCCB, FC_DB_UPDATEORACLE,
					sizeof(struct PRM_DB_UPDATEORACLE),
					strlen(buf) + 1);
	}
ret:
	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}
}

/*=======================================================================
 |
 |		ORACLE pR[h폜
 |
 |	VOID	PSDBDeleteOracle(pFCB, key)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |		CHAR	*key;		L[
 |
 =======================================================================*/
VOID	PSENTRY PSDBDeleteOracle(PFCB pFCB, CHAR *key)
{
	PCCB	pCCB;
	struct	PRM_DB_DELETEORACLE	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = ERROR_CLIENT_NOSUPPORT;
	} else {
		if (strlen(key) >= sizeof(pParam->key)) {
			err = ERROR_CLIENT_PARAMETER;
			goto ret;
		}

		pParam = (struct PRM_DB_DELETEORACLE *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;
		strcpy(pParam->key, key);

		err = SendCommand(pCCB, FC_DB_DELETEORACLE,
					sizeof(struct PRM_DB_DELETEORACLE),
					0);
	}
ret:
	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}
}

/*=======================================================================
 |
 |		SR[hR[hǂݍ
 |
 |	SHORT	PSDBReadAll(pFCB, pBuf)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |		CHAR	*pBuf;		R[hǂݍ݃obt@|C^
 |
 |		SHORT	Ԓl		1:ǂݍ񂾁@0:EOF܂̓G[
 |
 =======================================================================*/
SHORT	PSENTRY PSDBReadAll(PFCB pFCB, CHAR *pBuf)
{
	PCCB	pCCB;
	SHORT	rc;
	SHORT	err = 0;

	pCCB = pFCB->pCCB;

	if (pFCB->pReadBuffer == NULL) {
		if ((pFCB->pReadBuffer = malloc(READ_BUFFER_SIZE)) == NULL) {
			err = ERROR_CLIENT_MEMORY;
			goto ret;
		}
		pFCB->readBufRecord = 0;
		pFCB->readBufCounter = 0;
	}

	if (pFCB->readBufRecord == pFCB->readBufCounter) {
		pFCB->readBufRecord = (USHORT)PSDBReadNext(pFCB,
				(SHORT)(READ_BUFFER_SIZE / pFCB->readSize),
				pFCB->pReadBuffer);
		pFCB->readBufCounter = 0;
	}

	if (pFCB->readBufRecord == 0)
		rc = 0;
	else {
#if defined (OS_WINDOWS)
		hmemcpy(pBuf, pFCB->pReadBuffer +
				(pFCB->readBufCounter++ * pFCB->readSize),
				pFCB->readSize);
#else
		memcpy(pBuf, pFCB->pReadBuffer +
				(pFCB->readBufCounter++ * pFCB->readSize),
				pFCB->readSize);
#endif
		rc = 1;
	}

ret:
	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}

	return rc;
}

/*=======================================================================
 |
 |		CfbNXpbN
 |
 |	VOID	PSDBPackIndex(pCCB, fileName)
 |
 |		PCCB	pCCB;		NCAgubN|C^
 |		CHAR	*fileName;	CfbNXt@C
 |
 |		SHORT	Ԓl		G[R[h
 |
 =======================================================================*/
VOID	PSENTRY PSDBPackIndex(PCCB pCCB, CHAR *fileName)
{
	struct	PRM_DB_PACKINDEX	*pParam;
	SHORT	err;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBPackIndex(fileName);
	} else {
		if (strlen(fileName) >= sizeof(pParam->fileName)) {
			err = ERROR_CLIENT_PARAMETER;
			goto ret;
		}

		pParam = (struct PRM_DB_PACKINDEX *)pCCB->command.param;
		strcpy(pParam->fileName, fileName);

		err = SendCommand(pCCB, FC_DB_PACKINDEX,
					sizeof(struct PRM_DB_PACKINDEX), 0);
	}
ret:
	if (err != 0) {
		pCCB->errorCode = err;
	}
}

/*=======================================================================
 |
 |		oCif[^ǂݍ
 |
 |	LONG	PSDBReadBinary(pFCB, fieldName, pBuf, bufSize)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |		CHAR	*fieldName;	tB[h
 |		CHAR	*pBuf;		ǂݍ݃obt@
 |		LONG	bufSize;	ǂݍ݃obt@TCY
 |
 |		LONG	Ԓl		ǂݍ񂾃oCg
 |
 =======================================================================*/
LONG	PSENTRY	PSDBReadBinary(PFCB pFCB, CHAR *fieldName, CHAR *pBuf,
								LONG bufSize)
{
	PCCB	pCCB;
	struct	PRM_DB_READBINARY	*pParam;
	LONG	readSize;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBReadBinary(pFCB->pDB, fieldName, pBuf, bufSize,
								&readSize);
	} else {
		pParam = (struct PRM_DB_READBINARY *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;
		if (fieldName != NULL)
			strcpy(pParam->field, fieldName);
		else
			strcpy(pParam->field, "");
		pParam->len = bufSize;

		pCCB->pOutData = pBuf;

		err = SendCommand(pCCB, FC_DB_READBINARY,
					sizeof(struct PRM_DB_READBINARY), 0);

		readSize = pCCB->extReceiveDataLength;
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}

	return readSize;
}

/*=======================================================================
 |
 |		oCif[^
 |
 |	VOID	PSDBWriteBinary(pFCB, fieldName, pBuf, bufSize)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |		CHAR	*fieldName;	tB[h
 |		CHAR	*pBuf;		݃f[^
 |		LONG	bufSize;	݃f[^TCY
 |
 =======================================================================*/
VOID	PSENTRY	PSDBWriteBinary(PFCB pFCB, CHAR *fieldName, CHAR *pBuf,
								LONG dataSize)
{
	PCCB	pCCB;
	struct	PRM_DB_WRITEBINARY	*pParam;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBWriteBinary(pFCB->pDB, fieldName, pBuf, dataSize);
	} else {
		pParam = (struct PRM_DB_WRITEBINARY *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;
		if (fieldName != NULL)
			strcpy(pParam->field, fieldName);
		else
			strcpy(pParam->field, "");
		pParam->len = dataSize;

		pCCB->pInData = pBuf;
		pCCB->extSendDataLength = dataSize;

		err = SendCommand(pCCB, FC_DB_WRITEBINARY,
					sizeof(struct PRM_DB_WRITEBINARY), 0);
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}
}

/*=======================================================================
 |
 |		oCif[^TCY擾
 |
 |	LONG	PSDBGetBinarySize(pFCB, fieldName)
 |
 |		PFCB	pFCB;		t@CubN|C^
 |		CHAR	*fieldName;	tB[h
 |
 |		LONG	Ԓl		oCif[^TCY
 |
 =======================================================================*/
LONG	PSENTRY	PSDBGetBinarySize(PFCB pFCB, CHAR *fieldName)
{
	PCCB	pCCB;
	struct	PRM_DB_GETBINARYSIZE	*pParam;
	LONG	dataSize;
	SHORT	err;

	pCCB = pFCB->pCCB;

	if (pCCB->chType == CHT_LOCAL) {
		err = DBGetBinarySize(pFCB->pDB, fieldName, &dataSize);
	} else {
		pParam = (struct PRM_DB_GETBINARYSIZE *)pCCB->command.param;
		pParam->handle = pFCB->fileHandle;
		strcpy(pParam->field, fieldName);

		err = SendCommand(pCCB, FC_DB_GETBINARYSIZE,
				sizeof(struct PRM_DB_GETBINARYSIZE), 0);

		dataSize = pCCB->response.ret.lValue;
	}

	if (err != 0) {
		pCCB->errorCode = err;
		pFCB->errorCode = err;
		if (pCCB->pErrHandler != NULL)
			(*pCCB->pErrHandler)(pFCB, err);
	}

	return dataSize;
}
